﻿var location="26063";
var locationName="Санкт-Петербург";
var xmlData=null;

function init() {
	System.Gadget.settingsUI="Settings.html";
	System.Gadget.onSettingsClosed=settingsClosed;
	if (System.Gadget.Settings.read("Location")!='') {
		location=System.Gadget.Settings.read("Location");
		locationName=System.Gadget.Settings.read("LocationName");
	} else {
		System.Gadget.Settings.write("Location", location);
	}

	initLayout();

	if (location!="") {
		onTimer();
	}	
}

function initLayout() {
	with (document.body.style) {
		width = "130px";
		height = "80px";
	}
	background.style.width = "130px";
	background.style.height = "80px";
	background.src = "url(images/square80.png)";

	var img=document.getElementById("background2");
	img.style.width = "130px";
	img.style.height = "80px";
	img.src = "images/square_highlights80.png";

}


function GetWeatherImage(fc) {
     if (fc) {
	var img = ""
	var p = fc.m_Phenomena.m_Precipitation;
	var c = fc.m_Phenomena.m_Cloudiness;
	if (fc.m_Tod==0) ext='n.png'; else ext='.png';
	if ((p==4) || (p==5))
	{
		if (c==2) { img="4"; }
		if (c==3) { img="5"; }
		
	}
	if ((p==6) || (p==7))
	{
		if (c==2) {img="6"; }
		if (c==3) {img="7"; }
	}
	if (p==8) 
	{
		img="8";
	}
	if (p==10) 
	{
		if (c==0) img="0";
		if (c==1) img="1";
		if (c==2) img="2";
		if (c==3) img="3";
	}
	if (p==9) 
	{
		img="9";
	}
     } else {
	img="9";
     }
	return "pics/"+img+ext;	
}

function settingsClosed() {
	location=System.Gadget.Settings.read("Location");
	locationName=System.Gadget.Settings.read("LocationName");
	DataComplete=false;
	onTimer();
}

var tod = new Array("Ночь","Утро","День","Вечер")
var wind=new Array("Северный","Северо-восточный","Восточный","Юго-восточный","Южный","Юго-западный","Западный","Северо-западный");
var idx = 0;
var swapint = 15;
var updateDate = new Date(0);

function onTimer() {
    var date = new Date(System.Time.getLocalTime(System.Time.currentTimeZone));
    with (date)
    {
        hours = getHours();
        minutes = getMinutes();
        seconds = getSeconds();
    }
    var diff = (date.getTime() - updateDate.getTime())/(60*1000); // minutes diff
    if ((diff >= 30) || (!DataComplete)) {
	DataComplete=false;
	loadData(location);
	if (DataComplete) {
	updateDate = date;
	}
    }
    retrieveWeather();
    self.setTimeout( "onTimer()", 1000 * swapint );
}

function retrieveWeather() {
	if (DataComplete) {
		try {
		city = locationName; //dataTOWN.m_Name;
		if (city.length>20) {
			city=city.substr(0,19) + "...";
		}

		var fc = dataTOWN.m_Forecasts[idx];

		gadgetCity.innerHTML=city;
		gadgetTime.innerHTML= fc.m_Day + "." + fc.m_Month + "." + fc.m_Year + "<br>" + tod[fc.m_Tod];
		var tmp = (parseInt(fc.m_Temperature.m_Min) + parseInt(fc.m_Temperature.m_Max))/2;
		var plus = (tmp>0)?"+":"";
		gadgetTemperature.innerHTML=plus + String(tmp) + "&deg;C";
		var tmpc = (parseInt(fc.m_Heat.m_Min) + parseInt(fc.m_Heat.m_Max))/2;
		var win = (parseInt(fc.m_Wind.m_Min) + parseInt(fc.m_Wind.m_Max))/2;

		var alt_string = "";
		alt_string += "Ветер "+wind[fc.m_Wind.m_Direction]+" "+String(win)+" м/сек\n";
		alt_string += "Атм. давление "+String((parseInt(fc.m_Pressure.m_Min) + parseInt(fc.m_Pressure.m_Max))/2) + " мм.рт.ст.\n";
		alt_string += "Влажность "+String((parseInt(fc.m_Relwet.m_Min) + parseInt(fc.m_Relwet.m_Max))/2)+"%\n";
		alt_string += "Комфорт "+String(tmpc) + "°C"+"\n";
		var img=document.getElementById("image");
		img.src=GetWeatherImage(fc);
		img.alt=alt_string;
		var img2=document.getElementById("background2");
		img2.alt=alt_string;
		} catch (e) {

		}


		idx++;
                if (idx >= dataTOWN.m_Forecasts.length) {idx=0;}
	} else {
		gadgetTime.innerHTML="НЕТ<br>ДАННЫХ";
		var img=document.getElementById("image");
		img.src=GetWeatherImage(null);
	}
}

function showExtendedFlyout() {
	if (System.Gadget.Flyout.show==false) {
		if (DataComplete) {
			System.Gadget.Flyout.file = "weatherExtended.html";
			System.Gadget.Flyout.show=true;
			System.Gadget.Flyout.onHide = blankFunction;
		}
	} else {
		System.Gadget.Flyout.show=false;
	}
}

function blankFunction() {}

function loadCityPage() {
	if (DataComplete) {
		var shell = new ActiveXObject("WScript.Shell");
		shell.Run("http://www.gismeteo.ru/ztowns/"+location.toString()+".htm");
	}
}

